from http.server import HTTPServer, SimpleHTTPRequestHandler
from urllib.parse import urlparse,parse_qs
import time
import subprocess
from subprocess import PIPE
import threading
import datetime
import RPi.GPIO as GPIO

n_min = 0
n_hour = 0
flg_state = 0
pic_no = 0

proc_pt = subprocess.Popen("clear",shell=True)
GPIO.setmode(GPIO.BCM)      
GPIO.setup(17, GPIO.OUT)   
GPIO.output(17,1)        
GPIO.setup(4, GPIO.IN, GPIO.PUD_UP) 

class MyHandler(SimpleHTTPRequestHandler):

    def do_GET(self):
        global n_min, n_hour, flg_state, proc_pt, pic_no
            
        self.send_response(200)

        fl = 1
        if self.chk_file() == 0:
            parsed = urlparse(self.path)
            params = parse_qs(parsed.query)
            a=next(iter(params))

        #-----  Take Picture  -----------------
            if a == "1":
                cmd = "fswebcam ./data.jpg"
                proc = subprocess.Popen(cmd.split())

        #-----  Start  -----------------
            if a == "2":
                flg_state = 1
                b = params['2'][0]
                b = b.split(",")
                n_hour = int(b[0])
                n_min = int(b[1]) 

                GPIO.add_event_detect(4, GPIO.FALLING, callback=self.take_pic)
                pic_no = 0
                self.take_pic(0)

        #-----  Stop  -----------------
            if a == "3":
                flg_state = 0
                GPIO.remove_event_detect(4)
                proc_pt.kill()

        #-----  Data transfer  --------------
            elif a == "80":
                self.send_header('Content-type', "text/plain")
                self.end_headers()

                buf = (str(n_hour) + ',' + str(n_min) + ',' + str(flg_state) + ',')
                self.wfile.write(buf.encode())

                fl = 0

       #-------------------------------------
        else :
            fl = 0

        if fl == 1:
            f = open("camera.html",'rb')
            self.send_header('Content-type', "text/html")
            self.end_headers()
            self.wfile.write(f.read())
            f.close()

    #-------------------------------------------------
    def chk_file(self):

        a=0
        if self.path == "/":
            self.path = "/camera.html"
            dataType = "text/html"
            a=1
        if self.path.endswith(".css"):
            dataType = "text/css"
            a=1
    
        if self.path.endswith(".js"):
            dataType = "application/javascript"
            a=1
    
        if self.path.endswith(".txt"):
            dataType = "text/plain"
            a=1
    
        if self.path.endswith(".jpg"):
            dataType = "image/jpeg"
            a=1
   
        if self.path.endswith(".png"):
            dataType = "image/png"
            a=1
    
        if self.path.endswith(".ico"):
            dataType = "text/plain"
            a=1

        if a == 1:
            self.path = "." + self.path
            f = open(self.path,'rb')
            self.send_header('Content-type', dataType)
            self.end_headers()
            self.wfile.write(f.read())
            f.close()

        return a
#---------------------------------------------------------
    def take_pic(self,dummy):
        global n_min, n_hour, proc_pt, pic_no

        cmd = "fswebcam data/data_" + format(pic_no,"04d") + ".jpg"
        pic_no += 1
        proc_pt = subprocess.Popen(cmd.split())
        print(cmd)

        cmd = "python3 p_timer.py " + str((n_hour * 60) + n_min)
        proc_pt = subprocess.Popen(cmd.split())

    #-------------------------------------------------

host = ''
port = 8080
httpd = HTTPServer((host, port), MyHandler)
print('serving at port', port)
httpd.serve_forever()






